#--*-coding:utf-8-*--

class IronAndBiscuits < DiceBot
  
  def initialize
    super
    @sendMode = 2
    @sortType = 1
    @d66Type = 2
  end
  def gameName
    'アイロンとビスケット'
  end
  
  def gameType
    "IronAndBiscuits"
  end
  
  def prefixs
    ['(\d+RC|BPAT|PAT|RMT|RNT|RAT|RGT|\d+PAT).*']
  end
  
  def getHelpMessage
    info = <<INFO_MESSAGE_TEXT
・判定コマンド　xRCa,b
　（x＝ダイス数、ab＝使用特技の目（省略可能））
・戦闘時使用部位コマンド　BPAT
・部位コマンド　xPAT
(x=ダイス数（省略可能）)
・苗字ランダムコマンド　RMT
・名前ランダムコマンド　RNT
・特技ランダムコマンド　RAT
・がらくた作成ランダムコマンド　RGT
INFO_MESSAGE_TEXT
  end
  
  
  
  def rollDiceCommand(command)
    debug("rollDiceCommand begin string", command)
    
    result = ''
    
    result = checkRoll(command)
    return result unless(result.empty?)
    
    
    debug("各種表として処理")
    return rollTableCommand(command)
  end
  
  
  def checkRoll(string)
    debug("checkRoll begin string", string)
    
    return '' unless(/^(\d+)RC(\d+)?(,(\d+))?(,(\d+))?$/i =~ string)
    
    roll_times = $1.to_i
    target1 = $2.to_i
    target2 = $4.to_i
    target3 = $6.to_i
    
    
    result = "ダイス数：#{roll_times}、ターゲット："
    
    result +="#{target1}"    if(target1 != 0)
    result +="、#{target2}"    if(target2 != 0)
    result +="、#{target3}"    if(target3 != 0)
    result +="なし"    if(target1 == 0 and target2 == 0 and target3 == 0)
    result +="　＞　出目："
    
    roll_times.times do |i|
        d1, = roll(1, 6)
        result += "#{d1}"
        result += "【成功】" if(target1==d1 || target2==d1 || target3==d1 || d1==6)
		result += "、" if(roll_times>i+1)
    end 
    

    return result
  end

  
  ####################
  # 各種表
  
  def rollTableCommand(command)
    command = command.upcase
    result = []
    
    debug("rollDiceCommand command", command)
    
    counts = 1
    
    case command
    when "BPAT"
      result = choicepatTable(2)
    when "PAT"
      result = choicepatTable(1)
    when "RMT"
      result = choicemyoujiTable(counts)
    when "RNT"
      result = choicenameTable(counts)
    when "RAT"
      result = choiceabiTable(5)
    when "RGT"
      result = choicemakeTable(6)
    else

    return '' unless(/(\d+)PAT/i =~ command)
      result = choicepatTable($1.to_i)
      return result

    end
    
    return result
  end


###呼び出し＋α

  def choicepatTable(counts)
      
      name = "部位決定"
      text = "#{name}："      

      counts.times do |i|
      
        d1, = roll(1,6)
        case d1
        when 1
        text += "出目１＞頭"
        when 2
        text += "出目２＞胴"
        when 3
        text += "出目３＞右腕"
        when 4
        text += "出目４＞左腕"
        when 5
        text += "出目５＞右足"
        when 6
        text += "出目６＞左足"
        end

		text += "、" if(counts>i+1)
      end

     return text
  end


  def choicemyoujiTable(counts)

    myoujiTable =[
             [11, '冬野'],
             [12, '山田'],
             [13, 'サイレンス'],
             [14, '岡本'],
             [15, 'ベントレー'],
             [16, 'マクドナルド'],
             [22, 'ブラウン'],
             [23, '鈴木'],
             [24, '本田'],
             [25, '下村'],
             [26, 'パウエル'],
             [33, 'ウォルターズ'],
             [34, '王'],
             [35, 'ブラック'],
             [36, 'レイ'],
             [44, 'アダム'],
             [45, 'ケインズ'],
             [46, '小坂'],
             [55, 'ライアン'],
             [56, 'サンダース'],
             [66, '綾小路'],
            ]
      
      name = "苗字ランダム表"
      text = "#{name}:"      

      counts.times do |i|
      
        number3, = d66(2)
        text += "出目#{number3}＞#{get_table_by_number(number3, myoujiTable)}"
      end

     	result = []
    	result.push( text )

     return result
  end
  
  def choicenameTable(counts)

    nameTable =[
             [11, '香'],
             [12, '太郎'],
             [13, 'ルーシー'],
             [14, 'ルイ'],
             [15, '桜花'],
             [16, '玲'],
             [22, 'ジョン'],
             [23, '大五朗'],
             [24, 'アレン'],
             [25, 'サンデー'],
             [26, '一郎'],
             [33, 'ジェフ'],
             [34, 'ミーシャ'],
             [35, '花子'],
             [36, 'カナタ'],
             [44, 'チャーリー'],
             [45, 'アリス'],
             [46, 'カーネル'],
             [55, 'ハーベイ'],
             [56, 'ドナルド'],
             [66, 'ハル'],
            ]
      
      name = "名前ランダム表"
      text = "#{name}:"      

      counts.times do |i|
      
        number3, = d66(2)
        text += "出目#{number3}＞#{get_table_by_number(number3, nameTable)}"
      end

	    result = []
    	result.push( text )

     return result

  end
  
  def choiceabiTable(counts)

    abiTable =[
             [11, '歌'],
             [12, '説得'],
             [13, '泣き落とし'],
             [14, '道案内'],
             [15, '学問（文）'],
             [16, '人情話'],
             [22, '跳躍'],
             [23, 'うわばみ'],
             [24, '変装'],
             [25, '治療'],
             [26, '大食い'],
             [33, '学問（理）'],
             [34, '俊足'],
             [35, '料理'],
             [36, '経理'],
             [44, '記憶術'],
             [45, '隠蔽'],
             [46, '機械工作'],
             [55, '乗物操縦'],
             [56, '格闘'],
             [66, '水泳'],
            ]
      
      name = "特技ランダム表"
      text = "#{name}:"      

      counts.times do |i|
      text += "<" + (i+1).to_s + ">"
        number3, = d66(2)
        text += "出目#{number3}＞#{get_table_by_number(number3, abiTable)}"
text += "\n"
      end

	    result = []
    	result.push( text )

     return result

  end
  
  
  def choicemakeTable(counts)
      
      name = ""
      text = "#{name}"      
	text2 = ""
      counts.times do |i|
      text += "<" + (i+1).to_s + ">"
        d1, = roll(2,6)
        case d1
        when 2
        text += "大きな"
	text2 += "（この部位での行動は、対象を好きなだけ取れる。"
        when 3
        text += "頑丈な"
	text2 += "（自身へのダメージを常に１点軽減する。"
        when 4
        text += "アンティークの"
	text2 += "（この部位での攻撃はダメージ部位を選べる。"
        when 5
        text += "古ぼけた"
	text2 += "（『古ぼけた』でない部位がある限り破壊されない。（アンティークに有効）。"
        when 6
        text += "断熱式の"
	text2 += "（この部位は熱量を増加させない。"
        when 7
        text += "おんぼろの"
	text2 += "（この部位での熱量増加が２倍。"
        when 8
        text += "壊れやすい"
	text2 += "（この部位は優先的に破壊される（アンティークには無効）。"
        when 9
        text += "金属質の"
	text2 += "（この部位で接触行動をすると、相手の熱量を自分と同じにする。"
        when 10
        text += "鋭い"
	text2 += "（この部位での攻撃にダメージ１点追加。"
        when 11
        text += "最新式の"
	text2 += "（この部位での動力増加が２倍。"
        when 12
        text += "職人細工の"
	text2 += "（この部位は１度で２回機能する。"
        end

        d1, = roll(1,6)
	if i>3 then
        case d1
        when 1
        text += "『バネ（ジャンプブーツ）』"
	text2 += "使用時、動力＋３）"
        when 2
        text += "『歯車（ギミック）』"
	text2 += "使用時、熱量が１０点以下の時、部位表を振って、出目の部位を使用する。即座に軽減不能の熱量＋１）"
        when 3
        text += "『羽箒（羽）』"
	text2 += "使用時、このターンの終了時まで自身への接触行動を無効化してもよい。熱量＋３）"
        when 4
        text += "『バネ（ジャンプブーツ）』"
	text2 += "使用時、動力＋３）"
        when 5
        text += "『歯車（ギミック）』"
	text2 += "使用時、熱量が１０点以下の時、部位表を振って、出目の部位を使用する。熱量＋１）"
        when 6
        text += "『羽箒（羽）』"
	text2 += "使用時、このターンの終了時まで自身への接触行動を無効化してもよい。熱量＋３）"
        end
	elsif i>1 then
        case d1
        when 1
        text += "『文鎮（金棒）』"
	text2 += "使用時、対象一人に１＋動力点の接触攻撃。対象を変更されない。熱量＋５）"
        when 2
        text += "『輪ゴム鉄砲（弓矢）』"
	text2 += "使用時、対象一人に１＋動力点の非接触攻撃。熱量＋３）"
        when 3
        text += "『鏡（盾）』"
	text2 += "使用時、ターンの終了まで対象一人を守護する。熱量＋２）"
        when 4
        text += "『鋏（剣）』"
	text2 += "使用時、対象一人に１＋動力点の接触攻撃。熱量＋２）"
        when 5
        text += "『接着剤（包帯）』"
	text2 += "使用時、対象一人の破壊された任意の部位一つを回復する）"
        when 6
        text += "『ティーポット』"
	text2 += "攻撃でも回復でもない。対象一人に飲み物を注ぐ）"
        end
	else
        case d1
        when 1
        text += "『電池（願望）』"
	text2 += "動力＋３。）"
        when 2
        text += "『冷却ファン（思想）』"
	text2 += "使用時、自身の熱量を０にする。）"
        when 3
        text += "『アイロン（信仰心）』"
	text2 += "使用時、自身の熱量を＋１０する。）"
        when 4
        text += "『蒸気タービン（情熱）』"
	text2 += "熱量の１０を超えた分を動力に変換。）"
        when 5
        text += "『蒸気タービン（情熱）』"
	text2 += "熱量の１０を超えた分を動力に変換。）"
        when 6
        text += "『冷却ファン（思想）』"
	text2 += "使用時、自身の熱量を０にする。）"
        end
	end

		text += "\n    " + text2 + "\n" 
	text2=""
	text if(counts>i+1)
      end
     return text
  end




end